//+------------------------------------------------------------------+
//|                                             PriceSpreadRange.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//----
#property indicator_chart_window
//---- Indicator settings
extern bool Corner_of_Chart_RIGHT_TOP = True;
extern bool Show_Price = True;
extern bool Show_Xtra_Details = True;
extern bool Show_Smaller_Size = True;
extern int Shift_UP_DN = -50;
extern int Adjust_Side_to_side = 5;
extern color BarLabel_color = Gray;
extern color CommentLabel_color = Gray;
extern color color_m30 = Goldenrod;
double g_point_112;
string g_dbl2str_120;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   if (Point == 0.00001) g_point_112 = 0.0001;
   else {
      if (Point == 0.001) g_point_112 = 0.01;
      else g_point_112 = Point;
   }
   return (0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   ObjectsDeleteAll(0, OBJ_LABEL);
   return (0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   string ls_unused_84;
   color l_color_116;
   color l_color_120;
   int l_ind_counted_0 = IndicatorCounted();
   double l_ima_4 = iMA(Symbol(), 0, 1, 0, MODE_EMA, PRICE_CLOSE, 0);
   g_dbl2str_120 = DoubleToStr(l_ima_4, Digits);
   if (Show_Smaller_Size == False) {
      if (Show_Price == True) {
         ObjectCreate("Signalprice", OBJ_LABEL, 1, 0, 0);
         ObjectSetText("Signalprice", "" + g_dbl2str_120 + "", 24, "Century Gothic bold", color_m30);
         ObjectSet("Signalprice", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
         ObjectSet("Signalprice", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
         ObjectSet("Signalprice", OBJPROP_YDISTANCE, Shift_UP_DN + 58);
      }
   }
   if (Show_Smaller_Size == True) {
      if (Show_Price == True) {
         ObjectCreate("Signalprice", OBJ_LABEL, 1, 0, 0);
         ObjectSetText("Signalprice", "" + g_dbl2str_120 + "", 14, "Century Gothic bold", color_m30);
         ObjectSet("Signalprice", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
         ObjectSet("Signalprice", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
         ObjectSet("Signalprice", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
      }
   }
   int li_12 = 0;
   int li_16 = 0;
   int li_20 = 0;
   int li_24 = 0;
   int li_28 = 0;
   int li_32 = 0;
   li_12 = (iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1)) / g_point_112;
   for (li_32 = 1; li_32 <= 5; li_32++) li_16 = li_16 + (iHigh(NULL, PERIOD_D1, li_32) - iLow(NULL, PERIOD_D1, li_32)) / g_point_112;
   for (li_32 = 1; li_32 <= 10; li_32++) li_20 = li_20 + (iHigh(NULL, PERIOD_D1, li_32) - iLow(NULL, PERIOD_D1, li_32)) / g_point_112;
   for (li_32 = 1; li_32 <= 20; li_32++) li_24 = li_24 + (iHigh(NULL, PERIOD_D1, li_32) - iLow(NULL, PERIOD_D1, li_32)) / g_point_112;
   li_16 /= 5;
   li_20 /= 10;
   li_24 /= 20;
   li_28 = (li_12 + li_16 + li_20 + li_24) / 4;
   string ls_unused_36 = "";
   string ls_unused_44 = "";
   string l_dbl2str_52 = "";
   string l_dbl2str_60 = "";
   string l_dbl2str_68 = "";
   string l_dbl2str_76 = "";
   string ls_unused_92 = "";
   string ls_unused_100 = "";
   string ls_108 = "";
   double l_iopen_124 = iOpen(NULL, PERIOD_D1, 0);
   double l_iclose_132 = iClose(NULL, PERIOD_D1, 0);
   double ld_140 = (Ask - Bid) / g_point_112;
   double l_ihigh_148 = iHigh(NULL, PERIOD_D1, 0);
   double l_ilow_156 = iLow(NULL, PERIOD_D1, 0);
   l_dbl2str_60 = DoubleToStr((l_iclose_132 - l_iopen_124) / g_point_112, 0);
   l_dbl2str_52 = DoubleToStr(ld_140, Digits - 4);
   if (Point == 0.00001) l_dbl2str_68 = DoubleToStr(li_28, Digits - 5);
   else l_dbl2str_68 = DoubleToStr(li_28, Digits - 4);
   ls_108 = (iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1)) / g_point_112;
   l_dbl2str_76 = DoubleToStr((l_ihigh_148 - l_ilow_156) / g_point_112, 0);
   if (l_iclose_132 >= l_iopen_124) {
      ls_unused_92 = "-";
      l_color_116 = LimeGreen;
   }
   if (l_iclose_132 < l_iopen_124) {
      ls_unused_92 = "-";
      l_color_116 = Red;
   }
   if (l_dbl2str_68 > ls_108) {
      ls_unused_100 = "-";
      l_color_120 = LimeGreen;
   }
   if (l_dbl2str_68 < ls_108) {
      ls_unused_100 = "-";
      l_color_120 = Red;
   }
   if (Show_Smaller_Size == False) {
      if (Show_Xtra_Details == True) {
         if (Show_Price == True) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS7", "spread", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 100);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_52 + "", 12, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 100);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS9", "from open", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 115);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_60 + "", 12, "Century Gothic bold", l_color_116);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 115);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS11", "high to low", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 130);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_76 + "", 12, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 130);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS13", "dialy average", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 145);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_68 + "", 12, "Century Gothic bold", l_color_120);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 145);
         }
      }
   }
   if (Show_Smaller_Size == False) {
      if (Show_Xtra_Details == True) {
         if (Show_Price == False) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS7", "spread", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_52 + "", 12, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS9", "from open", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_60 + "", 12, "Century Gothic bold", l_color_116);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS11", "high to low", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_76 + "", 12, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS13", "dialy average", 10, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 45);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_68 + "", 12, "Century Gothic bold", l_color_120);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
         }
      }
   }
   if (Show_Smaller_Size == True) {
      if (Show_Xtra_Details == True) {
         if (Show_Price == True) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS7", "spread", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 80);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_52 + "", 9, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 80);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS9", "from open", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 95);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_60 + "", 9, "Century Gothic bold", l_color_116);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 95);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS11", "high to low", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 110);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_76 + "", 9, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 110);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS13", "dialy average", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 125);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_68 + "", 9, "Century Gothic bold", l_color_120);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 125);
         }
      }
   }
   if (Show_Smaller_Size == True) {
      if (Show_Xtra_Details == True) {
         if (Show_Price == False) {
            ObjectCreate("MMLEVELS7", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS7", "spread", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS7", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS7", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS7", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS8", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS8", "" + l_dbl2str_52 + "", 9, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS8", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS8", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS8", OBJPROP_YDISTANCE, Shift_UP_DN + 60);
            ObjectCreate("MMLEVELS9", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS9", "from open", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS9", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS9", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS9", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS10", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS10", "" + l_dbl2str_60 + "", 9, "Century Gothic bold", l_color_116);
            ObjectSet("MMLEVELS10", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS10", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS10", OBJPROP_YDISTANCE, Shift_UP_DN + 75);
            ObjectCreate("MMLEVELS11", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS11", "high to low", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS11", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS11", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS11", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS12", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS12", "" + l_dbl2str_76 + "", 9, "Century Gothic bold", Goldenrod);
            ObjectSet("MMLEVELS12", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS12", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS12", OBJPROP_YDISTANCE, Shift_UP_DN + 90);
            ObjectCreate("MMLEVELS13", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS13", "dialy average", 8, "Century Gothic", CommentLabel_color);
            ObjectSet("MMLEVELS13", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS13", OBJPROP_XDISTANCE, Adjust_Side_to_side + 40);
            ObjectSet("MMLEVELS13", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
            ObjectCreate("MMLEVELS14", OBJ_LABEL, 1, 0, 0);
            ObjectSetText("MMLEVELS14", "" + l_dbl2str_68 + "", 9, "Century Gothic bold", l_color_120);
            ObjectSet("MMLEVELS14", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
            ObjectSet("MMLEVELS14", OBJPROP_XDISTANCE, Adjust_Side_to_side + 10);
            ObjectSet("MMLEVELS14", OBJPROP_YDISTANCE, Shift_UP_DN + 105);
         }
      }
   }
   return (0);
}
//+------------------------------------------------------------------+